Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Remote_Token_Proxy Class Reference

Proxy for acquiring, renewing, and releasing a distributed synchronization token. More...

`#include <Remote_Tokens.h>`

Inheritance diagram for ACE_Remote_Token_Proxy:

[legend]
Collaboration diagram for ACE_Remote_Token_Proxy:

[legend]
List of all members.

## Public Methods
| ACE_Remote_Token_Proxy (void)
| Null construction. More...
virtual | ~ACE_Remote_Token_Proxy (void)
| Death. More...
int | open (const ACE_TCHAR *name, int ignore_deadlock=0, int debug=0)
| Same as Token_Proxy. More...
int | initiate_connection (void)
| Open a connection with the token server. More...
virtual int | acquire (int notify=0, void(*sleep_hook)(void *)=0, ACE_Synch_Options &options=ACE_Synch_Options::synch)
| Acquire the distributed token. More...
virtual int | tryacquire (void(*sleep_hook)(void *)=0)
| Try to acquire the distributed token. More...
virtual int | renew (int requeue_position=0, ACE_Synch_Options &options=ACE_Synch_Options::synch)
| Renew the token by offering to release it if there are any other waiters, otherwise get the token back immediately. More...
virtual int | release (ACE_Synch_Options &options=ACE_Synch_Options::synch)
| Release the distributed token. More...
virtual int | remove (ACE_Synch_Options &options=ACE_Synch_Options::synch)
| Become interface compliant for ACE_Guard<>. This has no functionality. More...
virtual void | token_acquired (ACE_TPQ_Entry *)
| Override the default to do nothing. More...
virtual const ACE_TCHAR * | owner_id (void)
| The client id of the current token holder. More...
void | dump (void) const
| Dump the state of the class. More...
## Static Public Methods
void | set_server_address (const ACE_INET_Addr &server_address)
| Sets the server address for all instances of ACE_Remote_Token_Proxy If this isn't called, the environment variable TOKEN_SERVER is checked for the server address. More...
## Protected Methods
int | request_reply (ACE_Token_Request &request, ACE_Synch_Options &options)
| Perform the request and wait for the reply. More...
## Protected Attributes
int | ignore_shadow_deadlock_
| If shadows report deadlock, go remote anyway. More...

## Detailed Description

Proxy for acquiring, renewing, and releasing a distributed synchronization token.

The Remote_Token_Proxy class implements the mechanisms for distributed token operations. It is similar to the ACE_Token_Proxy. = BUGS Distributed sleep_hooks have not been implemented. <owner_id> is not implemented.

## Constructor & Destructor Documentation

ACE_Remote_Token_Proxy::ACE_Remote_Token_Proxy | ( | void |  | ) |

| Null construction.

ACE_Remote_Token_Proxy::~ACE_Remote_Token_Proxy | ( | void |  | ) | `[virtual]`

| Death.

## Member Function Documentation

int ACE_Remote_Token_Proxy::acquire | ( | int | notify = 0,
|  | void(* | sleep_hook)(void *) = 0,
|  | ACE_Synch_Options & | options = ACE_Synch_Options::synch
| ) | `[virtual]`

| Acquire the distributed token. If notify is specified and the token is already held, the owner is notified. options contains the timeout value for the acquire call. The timer is kept at the token server. Asynchronous operations are not supported. Returns 0 on success, -1 on failure with <errno> == problem. Reimplemented from ACE_Token_Proxy.

void ACE_Remote_Token_Proxy::dump | ( | void |  | ) | const

| Dump the state of the class. Reimplemented from ACE_Token_Proxy. Reimplemented in ACE_Remote_Mutex, ACE_Remote_RLock, and ACE_Remote_WLock.

int ACE_Remote_Token_Proxy::initiate_connection | ( | void |  | ) |

| Open a connection with the token server. This only need be used when the user wishes to explicitly open a connection to check if the server exists. Connections are stored in the ACE_Token_Connections singleton as thread-specific data. That is, every thread has only one connection that is used for all remote tokens.

int ACE_Remote_Token_Proxy::open | ( | const ACE_TCHAR * | name,
|  | int | ignore_deadlock = 0,
|  | int | debug = 0
| ) | `[virtual]`

| Same as Token_Proxy. <name> is the string uniquely identifying the token. <ignore_deadlock> can be 1 to disable deadlock notifications. <debug> prints debug messages. Reimplemented from ACE_Token_Proxy.

const ACE_TCHAR * ACE_Remote_Token_Proxy::owner_id | ( | void |  | ) | `[virtual]`

| The client id of the current token holder. Reimplemented from ACE_Token_Proxy.

int ACE_Remote_Token_Proxy::release | ( | ACE_Synch_Options & | options = ACE_Synch_Options::synch | ) | `[virtual]`

| Release the distributed token. Similar to ACE_Local_Mutex, if the caller is not the owner, it is removed from the waiter list (if applicable.) Returns 0 on success, -1 on failure with <errno> == problem. Reimplemented from ACE_Token_Proxy.

int ACE_Remote_Token_Proxy::remove | ( | ACE_Synch_Options & | options = ACE_Synch_Options::synch | ) | `[virtual]`

| Become interface compliant for ACE_Guard<>. This has no functionality. Reimplemented from ACE_Token_Proxy.

int ACE_Remote_Token_Proxy::renew | ( | int | requeue_position = 0,
|  | ACE_Synch_Options & | options = ACE_Synch_Options::synch
| ) | `[virtual]`

| Renew the token by offering to release it if there are any other waiters, otherwise get the token back immediately. This renew has the same semantics as ACE_Local_Mutex release. It is semantically equivalent to <release> followed by <acquire>, but it is faster. options contains the timeout value used if renew blocks. As with acquire, the timer is maintained at the token server. If there are waiters and requeue_position == -1, the caller is queued at the rear of the waiter list. Otherwise, requeue_position specifies the number of waiters to "let by" before reacquiring the token (effectively, the position in the waiter list.) Reimplemented from ACE_Token_Proxy.

int ACE_Remote_Token_Proxy::request_reply | ( | ACE_Token_Request & | request,
|  | ACE_Synch_Options & | options
| ) | `[protected]`

| Perform the request and wait for the reply.

void ACE_Remote_Token_Proxy::set_server_address | ( | const ACE_INET_Addr & | server_address | ) | `[static]`

| Sets the server address for all instances of ACE_Remote_Token_Proxy If this isn't called, the environment variable TOKEN_SERVER is checked for the server address. If that is not specified, all ACE_Remote_** operations will fail.

void ACE_Remote_Token_Proxy::token_acquired | ( | ACE_TPQ_Entry * | e | ) | `[virtual]`

| Override the default to do nothing. Reimplemented from ACE_Token_Proxy.

int ACE_Remote_Token_Proxy::tryacquire | ( | void(* | sleep_hook)(void *) = 0 | ) | `[virtual]`

| Try to acquire the distributed token. If the token is already held, the call returns without queueing the caller as a waiter. Returns 0 on success (the token was acquired), and -1 with EWOULDBLOCK if the token was already held. Reimplemented from ACE_Token_Proxy.

## Member Data Documentation

int ACE_Remote_Token_Proxy::ignore_shadow_deadlock_`[protected]`

| If shadows report deadlock, go remote anyway.

The documentation for this class was generated from the following files:

- Remote_Tokens.h
- Remote_Tokens.cpp